// 8051F930gf[^K[
// sƁAWAKE_INTERVALŉxMOB
// MOf[^̓f[^tbV(1kB)ɕۑ
// \tgfobOpɒd̓[hSUSPENDݒȂ̂ŁAۂɎgpꍇSLEEPɕύX
// AiO͂P1.0`P1.7ɕύXꍇ́AADC0_init()ύX
// ۑtbVύXꍇff.asmɐV֐쐬Ă


//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <compiler_defs.h>             // compiler declarations
#include <C8051F930_defs.h>            // SFR declarations


extern void wr_dflash(int addr, int dat); 	// f[^tbVւ̏
extern void erase_dflash(int addr); 	// f[^tbV̏

//-----------------------------------------------------------------------------
// Global CONSTANTS
//-----------------------------------------------------------------------------

#define SYSCLK        20000000         // SYSCLK frequency in Hz
#define RTCCLK         32768           // smaRTClock frequency in Hz

#define WAKE_INTERVAL   2000           // Wakeup-interval in milliseconds
										// TvOƂȂB

#define SUSPEND          0x40          // Value to write to PMU0CF to place
                                       // the device in Suspend mode

#define SLEEP            0x80          // Value to write to PMU0CF to place
                                       // the device in Sleep Mode

#define POWER_MODE      SUSPEND        // Select between Suspend and Sleep
//#define POWER_MODE      SLEEP        // fobO͂łȂ̂ŒӁB
                                       // mode. When debugging, if the 
                                       // MCU is stopped/halted while 
                                       // in Sleep Mode, the connection
                                       // to the IDE will be lost. The 
                                       // IDE connection will not be lost
                                       // if the MCU is stopped/halted 
                                       // while in suspend mode.
                                               

#define RTC0CN    0x04                 // RTC address of RTC0CN register                
#define RTC0XCN   0x05                 // RTC address of RTC0XCN register 
#define RTC0XCF   0x06                 // RTC address of RTC0XCF register
#define RTC0PIN   0x07                 // RTC address of RTC0PIN register
#define ALARM0    0x08                 // RTC address of ALARM0 register
#define ALARM1    0x09                 // RTC address of ALARM1 register
#define ALARM2    0x0A                 // RTC address of ALARM2 register
#define ALARM3    0x0B                 // RTC address of ALARM3 register

//-----------------------------------------------------------------------------
// Function PROTOTYPES
//-----------------------------------------------------------------------------
void OSCILLATOR_Init (void);
void ADC0_Init(void);
void RTC_Init (void);
unsigned char RTC_Read (unsigned char);
void RTC_Write (unsigned char, unsigned char);

//-----------------------------------------------------------------------------
// MAIN Routine
//-----------------------------------------------------------------------------
void main (void)
{
	U8 wakeup_source;					// EF[NAbvpϐ
	int p0;								// tbṼCfbNXp
	int ad_dat0;						// ADϊf[^p

	PCA0MD &= ~0x40;                    // WDTE = 0 (clear watchdog timer enable)

//	PORT_Init ();                       // Initialize Port I/O
	OSCILLATOR_Init ();                 // Initialize Oscillator
	RTC_Init ();                        // Initialize RTC
	ADC0_Init();                        // Initialize ADC0
   
	erase_dflash(0x0);					// f[^tbV̈
	p0 = 0x0;

   //----------------------------------
   // Main Application Loop
   //----------------------------------
	while (1)
	{

		if(PMU0CF & 0x0C)                // Check if a smaRTClock Alarm or
		{                                // clock fail event has occured
			PMU0CF = 0x20;                // Clear all wake-up flags

         	PMU0CF = (POWER_MODE | 0x0C); 	// POWER_MODE(Sleep or Suspend)[hɓ
                                
         //--------------------------------------------------------------------
         // Device Sleeping until the next smaRTClock alarm
         //--------------------------------------------------------------------
         
         	wakeup_source = PMU0CF & 0x1F;
 
         // Clear the wake-up source flags
         	PMU0CF = 0x20;             

			if (p0 < 0x400)							// 0x400̓f[^tbV̑傫
			{
				ADC0CN |= 0x10;                     // ADC0 enabled, normal tracking,
				while ((ADC0CN & 0x20) == 0);		// ϊI҂
				ad_dat0 = ADC0;						// ad_data0͕ϊf[^
				ADC0CN &= ~0x20;					// ϊItONA
				wr_dflash(p0, ad_dat0);				// f[^tbVɏ
				p0 = p0 + 2;						// AhXi߂(int)
			}
      	}
	}                        
}

//-----------------------------------------------------------------------------
// Support Subroutines
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// RTC_Read ()
//-----------------------------------------------------------------------------
//
// Return Value : RTC0DAT
// Parameters   : 1) unsigned char reg - address of RTC register to read
//
// This function will read one byte from the specified RTC register.
// Using a register number greater that 0x0F is not permited.
//
//-----------------------------------------------------------------------------

unsigned char RTC_Read (unsigned char reg)
{
   reg &= 0x0F;                        // mask low nibble
   RTC0ADR  = reg;                     // pick register
   RTC0ADR |= 0x80;                    // set BUSY bit to read
   while ((RTC0ADR & 0x80) == 0x80);   // poll on the BUSY bit
   return RTC0DAT;                     // return value
}

//-----------------------------------------------------------------------------
// RTC_Write ()
//-----------------------------------------------------------------------------
//
// Return Value : none
// Parameters   : 1) unsigned char reg - address of RTC register to write
//                2) unsigned char value - the value to write to <reg>
//
// This function will Write one byte to the specified RTC register.
// Using a register number greater that 0x0F is not permited.
//-----------------------------------------------------------------------------
void RTC_Write (unsigned char reg, unsigned char value)
{
   reg &= 0x0F;                        // mask low nibble
   RTC0ADR  = reg;                     // pick register
   RTC0DAT = value;                    // write data
   while ((RTC0ADR & 0x80) == 0x80);   // poll on the BUSY bit
}


//-----------------------------------------------------------------------------
// Initialization Subroutines
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// OSCILLATOR_Init
//-----------------------------------------------------------------------------
//
// Return Value : None
// Parameters   : None
//
// This function initializes the system clock to use the internal precision
// oscillator.
//
//-----------------------------------------------------------------------------
void OSCILLATOR_Init (void)
{
   
   
   RSTSRC = 0x06;                      // Enable missing clock detector and
                                       // leave VDD Monitor enabled.

   CLKSEL = 0x04;                      // Select low power internal osc. 
                                       // divided by 1 as the system clock
  
}

//-----------------------------------------------------------------------------
// RTC_Init ()
//-----------------------------------------------------------------------------
//
// Return Value : None
// Parameters   : None
//
// This function will initialize the smaRTClock. 
//
//-----------------------------------------------------------------------------
void RTC_Init (void)
{
   unsigned char i;
   
   UU32 alarm_interval;   

   unsigned char CLKSEL_SAVE = CLKSEL;   


   RTC0KEY = 0xA5;                     // Unlock the smaRTClock interface
   RTC0KEY = 0xF1;

    
   RTC_Write (RTC0XCN, 0xC0);          // Enable Automatic Gain Control
                                       // and configure the smaRTClock
                                       // oscillator for crystal mode
   
   RTC_Write (RTC0XCF, 0x87);          // Enable Automatic Load Capacitiance
                                       // stepping and set the desired 
                                       // load capacitance to 7.5pF plus
                                       // the stray PCB capacitance

   RTC_Write (RTC0CN, 0x80);           // Enable smaRTClock oscillator
      

   //----------------------------------
   // Wait for smaRTClock to start
   //----------------------------------
   
   CLKSEL    =  0x74;                  // Switch to 156 kHz low power
                                       // internal oscillator
   // Wait > 2 ms
   for (i=0xFF;i!=0;i--);  

   // Wait for smaRTClock valid
   while ((RTC_Read (RTC0XCN) & 0x10)== 0x00); 
   

   // Wait for Load Capacitance Ready
   while ((RTC_Read (RTC0XCF) & 0x40)== 0x00); 
   
   //----------------------------------
   // smaRTClock has been started
   //----------------------------------
 

   RTC_Write (RTC0CN, 0xC0);           // Enable missing smaRTClock detector
                                       // and leave smaRTClock oscillator
                                       // enabled. 
   // Wait > 2 ms
   for (i=0xFF;i!=0;i--);  

   PMU0CF = 0x20;                      // Clear PMU wake-up source flags

   CLKSEL = CLKSEL_SAVE;               // Restore system clock
   while(!(CLKSEL & 0x80));            // Poll CLKRDY

   //----------------------------------
   // Set the smaRTClock Alarm
   //----------------------------------
   
   // Calculate the alarm interval in smaRTClock ticks
   alarm_interval.U32 = ((RTCCLK * WAKE_INTERVAL) / 1000L / 2);
   
   // Copy the alarm interval to the alarm registers
   RTC_Write (ALARM0, alarm_interval.U8[b0]);   // Least significant byte
   RTC_Write (ALARM1, alarm_interval.U8[b1]);
   RTC_Write (ALARM2, alarm_interval.U8[b2]);
   RTC_Write (ALARM3, alarm_interval.U8[b3]);   // Most significant byte

   // Enable the smaRTClock timer and alarm with auto-reset
   RTC_Write (RTC0CN, 0xDC);
}

//-----------------------------------------------------------------------------
// ADC0_Init
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void ADC0_Init (void)
{
   REF0CN = 4 + 1;                      // Select Temperature Sensor and internal voltage reference Enable
   ADC0MX = 0x1b;                      // Select temp. as the ADC input pin
   ADC0CF = ((SYSCLK/4000000)-1)<<3;   // Set SAR clock to 2MHz
   ADC0CF |= 0x03;                     // Select Delayed Track Mode and Gain of 1
   ADC0AC = 0x00;                      // Right-justify results, no shifting applied
   AD0EN = 1;                          // Enable ADC0
}

